let print_board (width, height, b) =
  print_string "Board:";
  print_newline ();
  print_int width;
  print_char ' ';
  print_int height;
  print_newline ();
  Array.iter (fun row -> print_string row; print_newline ()) b;
  flush stdout
;;

let print_config (uid, mcc, weight) =
  print_string "Config:";
  print_char ' ';
  print_int uid;
  print_char ' ';
  print_int mcc;
  print_char ' ';
  print_int weight;
  print_newline ();
  flush stdout
;;

let print_players players =
  let print_player (uid, x, y) =
    print_char '#';
    print_int uid;
    print_char ' ';
    print_int x;
    print_char ' ';
    print_int y;
    print_newline ()
  in
  List.iter print_player players
;;

let print_packages packages =
  let print_package (pid, dest_x, dest_y, weight) =
    print_string "Package:";
    print_char ' ';
    print_int pid;
    print_char ' ';
    print_int dest_x;
    print_char ' ';
    print_int dest_y;
    print_char ' ';
    print_int weight;
    print_newline ()
  in
  List.iter print_package packages
;;

let print_changes changes =
  let print_change (uid, act) =
    print_char '#';
    print_int uid;
    print_char ' ';
    begin match act with
      Protocol.AMove m -> print_char (Protocol.dir2char m)
    | Protocol.APick pid -> print_string "P "; print_int pid
    | Protocol.ADrop pid -> print_string "D "; print_int pid
    | Protocol.ANew (x, y) ->
        print_string "X "; print_int x; print_string " Y "; print_int y
    end;
    print_newline ()
  in
  List.iter print_change changes
;;
