type cell = Plain | Water | Wall | Coast;;
type dir = N | W | S | E;;

(* ruch, legalne argumenty: (0, 1), (0, -1), (1, 0), (-1, 0)
   podniesienie paczek o zadanych id
   upuszczenie paczek o zadanych id *)
type command = Move of dir | Pick of int list | Drop of int list;;

(* ruch, legalne argumenty: (0, 1), (0, -1), (1, 0), (-1, 0)
   upuszczenie paczki o zadanym id
   podniesienie paczki o zadanym id
   ustawienie wspolrzednych na zadane *)
type action = AMove of dir | ADrop of int | APick of int | ANew of int * int;;

val dir2char : dir -> char;;

(* send_command bid comm - wysyla rozkaz comm z zadanym bidem *)
val send_command : int -> command -> unit;;

(* receive_board () - odbiera opis planszy,
   zwraca plansze i liste baz *)
val receive_board : unit -> cell array array * (int * int) list;;

(* receive_config () - odbiera opis konfiguracji naszego robota,
  zwraca (identyfikator, pojemnosc, pieniadze) *)
val receive_config : unit -> int * int * int;;

(* receive_players () - odbiera opis polozenia graczy,
  zwraca liste (identyfikator, wspolrzedna_x, wspolrzedna_y) *)
val receive_players : unit -> (int * int * int) list;;

(* receive_packages () - odbiera opis dostepnych z danego miejsca paczek,
  zwraca liste (identyfikator, docelowa_wsp_x, docelowa_wsp_y, waga) *)
val receive_packages : unit -> (int * int * int * int) list;;

(* receivei_changes () - odbiera opis zmian po turze,
  zwraca liste (identyfikator_robota, zmiana_go_dotyczaca) *)
val receive_changes : unit -> (int * action) list * int list;;

(* connect host port - laczy sie z hostem przez port port *)
val connect : string -> int -> unit;;

(* disconnect () - zamyka polaczenie *)
val disconnect : unit -> unit;;
